/****************************************************************************
*
*    Copyright (c) 2005 - 2010 by Vivante Corp.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of Vivante Corporation. This is proprietary information owned by
*    Vivante Corporation. No part of this work may be disclosed,
*    reproduced, copied, transmitted, or used in any way for any purpose,
*    without the express written permission of Vivante Corporation.
*
*****************************************************************************
*
*
*****************************************************************************/




/*
 * Vivante specific definitions and declarations for EGL library.
 */

#ifndef __gc_egl_common_h_
#define __gc_egl_common_h_

#ifdef __cplusplus
extern "C" {
#endif

/*******************************************************************************
** Function prototypes.
**/

typedef void * (* veglCREATECONTEXT) (
	gcoOS Os,
	gcoHAL Hal,
	gctPOINTER SharedContext
	);

typedef EGLBoolean (* veglDESTROYCONTEXT) (
	void * Context
	);

typedef EGLBoolean (* veglFLUSHCONTEXT) (
	void * Context
	);

typedef EGLBoolean (* veglSETCONTEXT) (
	void * Context,
	gcoSURF Draw,
	gcoSURF Read,
	gcoSURF Depth,
	void * Priv
	);

typedef gceSTATUS (* veglSETBUFFER) (
	gcoSURF Draw
	);

typedef void (* veglFLUSH) (
	void
	);

typedef void (* veglFINISH) (
	void
	);

typedef gcoSURF (* veglGETCLIENTBUFFER) (
	void * Context,
	EGLClientBuffer Buffer
	);

typedef EGLenum (* veglBINDTEXIMAGE) (
	gcoSURF Surface,
	EGLenum Format,
	EGLenum Target,
	EGLBoolean Mipmap,
	EGLint Level
	);

typedef void (* veglPROFILER) (
	void * Profiler,
	gctUINT32 Enum,
	gctUINT32 Value
	);

typedef EGLenum (* veglCREATEIMAGETEXTURE)(
	EGLenum Target,
	gctINT Texture,
	gctINT Level,
	gctINT Depth,
	gctPOINTER Image
	);

typedef EGLenum (* veglCREATEIMAGERENDERBUFFER)(
	EGLenum Renderbuffer,
	gctPOINTER Image
	);

typedef	EGLenum (* veglCREATEIMAGEVGPARENTIMAGE)(
	unsigned int vgImage,
	void ** Images,
	int * Count
	);

#if !defined(STATIC_LINK)
EGLAPI
#endif
void * EGLAPIENTRY
veglGetCurrentAPIContext(
	void
	);

typedef struct _veglLOOKUP
{
	const char *								name;
	__eglMustCastToProperFunctionPointerType	function;
}
veglLOOKUP;

#define eglMAKE_LOOKUP(function) \
	{ #function, (__eglMustCastToProperFunctionPointerType) function }

typedef struct _veglDISPATCH
{
	veglCREATECONTEXT				createContext;
	veglDESTROYCONTEXT				destroyContext;
	veglSETCONTEXT					setContext;
	veglFLUSHCONTEXT				flushContext;

	veglFLUSH						flush;
	veglFINISH						finish;

	veglSETBUFFER					setBuffer;
	veglGETCLIENTBUFFER				getClientBuffer;

	veglCREATEIMAGETEXTURE			createImageTexture;
	veglCREATEIMAGERENDERBUFFER		createImageRenderbuffer;
	veglCREATEIMAGEVGPARENTIMAGE	createImageParentImage;
	veglBINDTEXIMAGE				bindTexImage;

	veglPROFILER					profiler;

	veglLOOKUP *					lookup;
}
veglDISPATCH;

#ifdef __cplusplus
}
#endif

#endif /* __gc_egl_common_h_ */

