/****************************************************************************
*
*    Copyright (c) 2005 - 2010 by Vivante Corp.  All rights reserved.
*
*    The material in this file is confidential and contains trade secrets
*    of Vivante Corporation. This is proprietary information owned by
*    Vivante Corporation. No part of this work may be disclosed,
*    reproduced, copied, transmitted, or used in any way for any purpose,
*    without the express written permission of Vivante Corporation.
*
*****************************************************************************
*
*
*****************************************************************************/




/*
 * Graphics API specific functions.
 */

#ifndef __gc_egl_graphics_h_
#define __gc_egl_graphics_h_

#include "gc_egl_os.h"
#include "gc_vdk_types.h"

#ifdef __cplusplus
extern "C" {
#endif

NativeDisplayType
veglGetDefaultDisplay(
	void
	);

void
veglReleaseDefaultDisplay(
	IN NativeDisplayType Display
	);

gctBOOL
veglGetDisplayInfo(
    IN NativeDisplayType Display,
#ifdef __QNXNTO__
	IN NativeWindowType Window,
#endif
	OUT gctPOINTER * Logical,
    OUT gctUINT32_PTR Physical,
    OUT gctINT32_PTR Stride,
	OUT gctINT32_PTR VirtualWidth,
	OUT gctINT32_PTR VirtualHeight
	);

void 
veglReleaseDisplayInfo(
    IN NativeDisplayType Display
    );


gctBOOL
veglGetDisplayBackBuffer(
	IN NativeDisplayType Display,
#ifdef __QNXNTO__
	IN NativeWindowType Window,
#endif
	OUT gctINT_PTR X,
	OUT gctINT_PTR Y,
	OUT gctUINT32_PTR Offset
	);

gctBOOL
veglSetDisplayFlip(
	IN NativeDisplayType Display,
#ifdef __QNXNTO__
	IN NativeWindowType Window,
#endif
	IN gctINT X,
	IN gctINT Y,
	IN gctUINT32 Offset
	);

gctBOOL
veglGetWindowInfo(
	IN VEGLDisplay Display,
	IN NativeWindowType Window,
	OUT gctINT_PTR X,
	OUT gctINT_PTR Y,
	OUT gctUINT_PTR Width,
	OUT gctUINT_PTR Height,
	OUT gctUINT_PTR BitsPerPixel,
	OUT gceSURF_FORMAT * Format,
	OUT gctUINT_PTR Flag
	);

gctBOOL
veglGetWindowBits(
    IN NativeDisplayType Display,
    IN NativeWindowType Window,
    OUT gctPOINTER * Logical,
    OUT gctUINT32_PTR Physical,
    OUT gctINT32_PTR Stride
    );

gctBOOL
veglDrawImage(
	IN VEGLDisplay Display,
	IN VEGLSurface Surface,
	IN gctPOINTER Bits,
	IN gctINT Left,
	IN gctINT Top,
	IN gctINT Width,
	IN gctINT Height
	);

gctBOOL
veglDrawPixmap(
	IN VEGLDisplay Display,
	IN EGLNativePixmapType Pixmap,
	IN gctINT Left,
	IN gctINT Top,
	IN gctINT Right,
	IN gctINT Bottom,
	IN gctINT Width,
	IN gctINT Height,
	IN gctINT BitsPerPixel,
	IN gctPOINTER Bits
	);

EGLint
veglGetNativeVisualId(
	VEGLDisplay Display
	);

gctBOOL
veglGetPixmapInfo(
	IN NativeDisplayType Display,
	IN NativePixmapType Pixmap,
	OUT gctUINT_PTR Width,
	OUT gctUINT_PTR Height,
	OUT gctUINT_PTR BitsPerPixel,
	OUT gceSURF_FORMAT * Format
	);

gctBOOL
veglGetPixmapBits(
	IN NativeDisplayType Display,
	IN NativePixmapType Pixmap,
	OUT gctPOINTER * Bits,
	OUT gctINT_PTR Stride,
	OUT gctUINT32_PTR Physical
	);

#if !defined(EGL_API_FB) && !defined(ANDROID)
gctBOOL
veglGetImageFromPixmap(
    IN NativeDisplayType Display,
    IN NativePixmapType Pixmap,
    OUT gctPOINTER * PixmapImage,
    OUT gctPOINTER * Bits,
    OUT gctINT_PTR Stride
    );

void
veglDestroyPixmapImage(void *image);

gctBOOL
veglPutImagetoPixmap(
	IN VEGLDisplay Display,
	IN NativePixmapType Pixmap,
	IN gctPOINTER		Bits
	);

void veglReportDamage(
	IN NativeDisplayType dpy,
	IN gctINT x,
	IN gctINT y,
	IN gctUINT w,
	IN gctUINT h
	);

gctBOOL 
veglGetParentWindowInfo(
	IN VEGLDisplay Display,
	IN NativeWindowType WindowHandle,
	OUT gctINT_PTR X,
	OUT gctINT_PTR Y,
	OUT gctUINT_PTR Width,
	OUT gctUINT_PTR Height,
	OUT gctUINT_PTR BitsPerPixel,
	OUT gceSURF_FORMAT * Format
	);
#endif


#ifdef __cplusplus
}
#endif

#endif /* __gc_egl_graphics_h_ */

